#include <string.h>
#include "itemlist.h"

extern char *ModuleName;

char *initialize   (item_list_t list);
char *declarations (item_list_t list);
char *param_names  (item_list_t list);
char *mysprintf    (char *format, ...);

/****************************************************/
static char *create_in_shape = "\
thread_t %s_create_in (scheduler_t _sched%s)\n\
{\n\
   thread_t _thread;\n\
   %s_data_t _locals = mymalloc (sizeof (struct %s_data_t));\n\
   %s\n\
   _thread = make_thread (_sched,%s_automaton,%s_finalize,_locals);\n\
   _locals->_state = 0;\n\
   link_to_scheduler (_sched,_thread);\n\
   return _thread;\n\
}";

static char *create_shape = "\
thread_t %s_create (%s)\n\
{\n\
    return %s_create_in (implicit_scheduler ()%s);\n\
}";

/****************************************************/
static char *create_in (item_list_t paramlist,char *params)
{
   char *cparams = (0 == strcmp ("",params)) ? params
                                   : mysprintf (",%s",params);
   return mysprintf (create_in_shape,
      ModuleName,cparams,
      ModuleName,ModuleName,
      initialize (paramlist),
      ModuleName,ModuleName);
}

static char *create (item_list_t paramlist,char *params)
{
   return mysprintf (create_shape,
      ModuleName,((0 == strcmp ("",params)) ? "void" : params),
      ModuleName,param_names (paramlist));
}

/****************************************************/
char *constructor (item_list_t paramlist)
{
   char *params = declarations(paramlist);
   return mysprintf ("%s\n%s\n",
		     create_in (paramlist,params),
		     create (paramlist,params));
}
