#include <stdio.h>
#include "loft_c.h"
#include "local.h"

/****************************************************/
extern char *ModuleName;
extern int run_exists;
void reset_state_num (void);
char *constructor (item_list_t paramlist);
char *mysprintf(char *format, ...);

/****************************************************/
static char *function_shape = "\
char %s_automaton (%s_data_t _local_vars)\n\
{\n\
LOFT_BEGIN_AUTOMATON\n\
%s;\n\
LOFT_END_AUTOMATON\n\
}";

static char *finalize_shape = "\
void %s_finalize (%s_data_t _local_vars)\n\
{\n\
       %s\n\
}";

static char *module_shape = "\
/*********** module %s *********/\n\
%s\n\
%s\n\
%s\n\
%s\n\
/**** end of module %s *********/";

/****************************************************/
static char *finalize (char *atom)
{
   return mysprintf (finalize_shape,
      ModuleName,ModuleName,
      (atom ? atom : ""));
}

/****************************************************/
char *Module (item_list_t params,char *fin,item_list_t locals,char *stat)
{
   char *builder   = constructor (params);
   char *function  = mysprintf (function_shape,ModuleName,ModuleName,stat);

   concat_local_data (params);
   concat_local_data (locals);

   add_local_data ("int","_state");

   if (run_exists) {
       add_local_data ("thread_t","_run");
       run_exists = 0;
   }

   reset_state_num ();

   return mysprintf (module_shape,
		     ModuleName,
		     local_data_structure (),
		     finalize (fin),
		     function,
		     builder,
		     ModuleName);
}

/****************************************************/
