#ifndef _INST_MAKE_H
#define _INST_MAKE_H

instruction_t make_nothing            (void);
instruction_t make_halt               (void);
instruction_t make_return             (void);
instruction_t make_cooperate          (void);
instruction_t make_sequence           (instruction_t,instruction_t);
instruction_t make_stop               (expression_t);
instruction_t make_suspend            (expression_t);
instruction_t make_resume             (expression_t);
instruction_t make_if                 (expression_t,instruction_t,instruction_t);
instruction_t make_inst_from_exp      (expression_t);
instruction_t make_repeat             (expression_t,instruction_t);
instruction_t make_generate           (expression_t);
instruction_t make_generate_valued    (expression_t,expression_t);
instruction_t make_await              (expression_t);
instruction_t make_limited_await      (expression_t,expression_t);
instruction_t make_atom               (void *(*selector)(),int n);
instruction_t make_join               (expression_t);
instruction_t make_limited_join       (expression_t,expression_t limit_exp);
instruction_t make_run                (expression_t);
instruction_t make_while              (expression_t,instruction_t);
instruction_t make_get_value          (expression_t,expression_t,void **var);

expression_t  make_wrapper            (void *(*selector)(),int n);
expression_t  make_const_expression   (void *item);
expression_t  make_thread_create      (instruction_t,void *locals);

#endif /* _INST_MAKE_H */
