#ifndef _THREAD_H
#define _THREAD_H

typedef void (*finalizer_t)();

typedef struct _thread_t
{
   struct _instruction_t  *run;
   finalizer_t             finalizer;
   void                   *locals;
   char                    state;
   char                    suspended;
   struct _event_t        *signal;
   struct _thread_t       *called;
   char                    code;
   struct _scheduler_t    *scheduler;
#ifdef OPTIM  
   int                     deadline;
#endif
}
*thread_t;

thread_t make_thread         (struct _scheduler_t*,
			      struct _instruction_t*,
			      finalizer_t final,
			      void *locals);

void     fire_thread         (thread_t);
void     finalize            (thread_t);

int      fireable            (thread_t);
void     return_processing   (thread_t,char val);

void     reset_thread_state  (thread_t);

#endif /* _THREAD_H */
